imports.gi.versions.Gtk = '3.0'
imports.gi.versions.Gdk = '3.0'

// imports.gi
const Hdy                = imports.gi.Handy
const Gdk                = imports.gi.Gdk
const Gtk                = imports.gi.Gtk
const Notify             = imports.gi.Notify
const { registerClass }  = imports.gi.GObject

// local modules
import { General }       from './pages/general.js'
import { Blacklist }     from './pages/blacklist.js'
import { Custom }        from './pages/custom.js'
import { _log }          from '../utils/log.js'

// types


// ----------------------------------------------------------------- end imports

const Prefs = registerClass (
    {},
    class extends Gtk.Application {
        _init () {
            super._init ()
            this.application_id = 'yi.github.rounded_corners_effect.prefs'
        }

        /** Prepare pages to show.*/
        setup (win) {
            win.add (new General ())
            win.add (new Blacklist ())
            win.add (new Custom ())
        }

        vfunc_activate () {
            super.vfunc_activate ()
            if (!this.win) {
                this.win = new Hdy.PreferencesWindow ({
                    application: this,
                    title: 'Preferences Page',
                })

                this.setup (this.win)
            }

            this.win.show_all ()
        }

        vfunc_startup () {
            super.vfunc_startup ()

            Hdy.init ()

            Notify.init (this.application_id)

            const css = new Gtk.CssProvider ()
            css.load_from_data (`
                .code { padding: 10px 16px;}
                .edit-win { background: #eeeeee; color: black; padding: 32px; }
                .flat { background: none; border: none;}`)
            const screen = Gdk.Screen.get_default ()
            if (screen) {
                Gtk.StyleContext.add_provider_for_screen (
                    screen,
                    css,
                    Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION
                )
            }
        }
    }
)

new Prefs ().run ([])

_log ('Prefs exited')
