const Gtk                      = imports.gi.Gtk
const GLib                     = imports.gi.GLib
const Gio                      = imports.gi.Gio


const { getCurrentExtension }  = imports.misc.extensionUtils

function init () {
    /** Do nothing here  */
}

// Preferences has been written by libhandy, to avoid maintain
// different UI for different version of Gnome shell.
// Libhandy is written in Gtk 3, so have to show it in new subprocess.

function buildPrefsWidget () {
    const widget = new Gtk.Box ()

    GLib.idle_add (GLib.PRIORITY_DEFAULT_IDLE, () => {
        widget.get_root ().close ()
        return false
    })

    const script = `${getCurrentExtension ().path}/preferences/index.js`
    const cmd = ['gjs', '-m', script]
    log ('Launch ' + cmd)

    Gio.Subprocess.new (cmd, Gio.SubprocessFlags.NONE)
    return widget
}
